<template>
  <div>
    <div class="flex justify-between items-top">
      <div class="text-h4 q-mb-md">
        Plánování
      </div>

      <div>
        <q-btn
          color="accent"
          icon="schedule"
          icon-right="add"
          label="Přidat"
          @click="addClick"
        />
      </div>
    </div>

    <q-table
      grid
      :rows="rows"
      :columns="columns"
      row-key="name"
      :pagination="initialPagination"
      :loading="loadingTable"
    >
      <template #item="props">
        <div class="q-pa-xs col-xs-12 col-sm-6 col-md-4">
          <q-card>
            <q-list>
              <q-item
                v-for="col in props.cols.filter(col => col.value !== null && col.value !== '')"
                :key="col.name"
              >
                <q-item-section>
                  <q-item-label>{{ col.label }}</q-item-label>
                </q-item-section>
                <q-item-section>
                  <q-item-label
                    caption
                    :class="{ 'text-bold': col.name === 'name' }"
                    lines="2"
                  >
                    {{ col.value }}
                  </q-item-label>
                </q-item-section>
              </q-item>
            </q-list>

            <q-separator />
            <q-card-section class="flex flex-center">
              <q-btn
                class="q-ml-xs q-mb-xs"
                color="primary"
                label="Upravit"
                size="sm"
                @click="onUpdate(props.row.id)"
              >
                <template #loading>
                  <q-spinner-gears />
                </template>
              </q-btn>

              <q-btn
                class="q-ml-xs q-mb-xs"
                color="negative"
                label="Smazat"
                size="sm"
                @click="onDelete(props.row.id)"
              >
                <template #loading>
                  <q-spinner-gears />
                </template>
              </q-btn>
            </q-card-section>
          </q-card>
        </div>
      </template>

      <template #loading>
        <q-inner-loading
          showing
          color="primary"
        />
      </template>
    </q-table>
  </div>
</template>

<script lang="ts">
import { ref } from '@vue/reactivity'
import _ from 'lodash'
import { useQuasar } from 'quasar'
import { PlannerModel } from 'web_trains_types'

import PlannerAddDialog from '@/components/Timetable/PlannerAddDialog.vue'
import { dateToStr, translateDay, translateMonth, translateTime } from '@/helper/dateTime'
import { plannerService } from '@/service'

const columns = [
  {
    name: 'name',
    field: (row: PlannerModel) => row.timetable ? row.timetable.name : '',
    label: 'Jízdní řád',
    required: false
  },
  {
    name: 'time',
    field: (row: PlannerModel) => translateTime(row.time).join(', '),
    label: 'Časy',
    required: false
  },
  {
    name: 'day',
    field: (row: PlannerModel) => translateDay(row.day).join(', '),
    label: 'Dny',
    required: false
  },
  {
    name: 'month',
    field: (row: PlannerModel) => translateMonth(row.month).join(', '),
    label: 'Měsíce',
    required: false
  },
  {
    name: 'once',
    field: (row: PlannerModel) => dateToStr(row.once, 'PPp'),
    label: 'Spustit jednou',
    required: false
  }
]

const initialPagination = {
  sortBy: 'name',
  descending: false,
  page: 1,
  rowsPerPage: 9
}

export default {
  name: 'Planner',
  setup (): any {
    const $q = useQuasar()

    const loadingTable = ref(true)
    const rows = ref<PlannerModel[]>()

    const loadData = () => {
      loadingTable.value = true

      plannerService.getAll()
        .then((data) => {
          rows.value = data
        })
        .finally(() => {
          loadingTable.value = false
        })
    }

    loadData()

    const addClick = () => {
      $q.dialog({
        component: PlannerAddDialog
      })
        .onOk(loadData)
    }

    const onDelete = (id: number) => {
      loadingTable.value = true

      plannerService.del(id)
        .then(() => {
          if (rows.value === undefined) {
            return
          }

          _.remove(rows.value, (obj) => obj.id === id)

          $q.notify({
            message: 'Plán smazán',
            type: 'positive'
          })
        })
        .finally(() => { loadingTable.value = false })
    }

    const onUpdate = (id: number) => {
      $q.dialog({
        component: PlannerAddDialog,
        componentProps: {
          id: id
        }
      })
        .onOk(loadData)
    }

    return {
      addClick,
      columns,
      initialPagination,
      loadingTable,
      rows,
      loadData,
      onDelete,
      onUpdate
    }
  }
}

</script>
